<?php
/**
 *
 * @copyright &copy; 2010 The Open University
 * @author a.j.forth@open.ac.uk
 * @license http://www.gnu.org/copyleft/gpl.html GNU Public License
 * @package dataplus
 */
require_once ($CFG->dirroot.'/course/moodleform_mod.php');

class mod_dataplus_mod_form extends moodleform_mod {

    function definition() {

        global $CFG, $COURSE;
        $mform =&$this->_form;

        $mform->addElement('header', 'general', get_string('general', 'form'));

        $mform->addElement('text', 'name', get_string('name'), array('size'=>'64'));
        if (!empty($CFG->formatstringstriptags)) {
            $mform->setType('name', PARAM_TEXT);
        } else {
            $mform->setType('name', PARAM_CLEAN);
        }
        $mform->addRule('name', null, 'required', null, 'client');

        $mform->addElement('htmleditor', 'intro', get_string('intro', 'dataplus'));
        $mform->setType('intro', PARAM_RAW);
        $mform->addRule('intro', null, 'required', null, 'client');
        $mform->setHelpButton('intro', array('writing', 'questions', 'richtext'), false, 'editorhelpbutton');

        $mform->addElement('date_selector', 'timeavailablefrom', get_string('availablefromdate', 'dataplus'), array('optional'=>true));

        $mform->addElement('date_selector', 'timeavailableto', get_string('availabletodate', 'dataplus'), array('optional'=>true));

        $mform->addElement('date_selector', 'timeviewfrom', get_string('viewfromdate', 'dataplus'), array('optional'=>true));

        $mform->addElement('date_selector', 'timeviewto', get_string('viewtodate', 'dataplus'), array('optional'=>true));
                                        
        $sizes = array(0=>get_string('none'), 1=>1,2=>2,3=>3,4=>4,5=>5,6=>6,7=>7,8=>8,9=>9,10=>10,15=>15,
		20=>20,30=>30,40=>40,50=>50,100=>100,200=>200,300=>300,400=>400,500=>500,1000=>1000);
		                                
        $mform->addElement('select', 'requiredentries', get_string('requiredentries', 'dataplus'), $sizes);
        $mform->setHelpButton('requiredentries', array('requiredentries', get_string('requiredentries', 'dataplus'), 'dataplus'));

        $mform->addElement('select', 'requiredentriestoview', get_string('requiredentriestoview', 'dataplus'), $sizes);
        $mform->setHelpButton('requiredentriestoview', array('requiredentriestoview', get_string('requiredentriestoview', 'dataplus'), 'dataplus'));

        $mform->addElement('select', 'maxentries', get_string('maxentries', 'dataplus'), $sizes);
        $mform->setHelpButton('maxentries', array('maxentries', get_string('maxentries', 'dataplus'), 'dataplus'));

        $mform->addElement('select', 'maxentriesperuser', get_string('maxentriesperuser', 'dataplus'), $sizes);
        $mform->setHelpButton('maxentriesperuser', array('maxentriesperuser', get_string('maxentriesperuser', 'dataplus'), 'dataplus'));        
        
        $ynoptions = array(1 => get_string('yes'), 0 => get_string('no'));
        $mform->addElement('select', 'studentediting', get_string('studentediting', 'dataplus'), $ynoptions);
        $mform->setHelpButton('studentediting', array('studentediting', get_string('studentediting', 'dataplus'), 'dataplus'));
        
        $mform->addElement('select', 'studenteditingother', get_string('studenteditingother', 'dataplus'), $ynoptions);
        $mform->setHelpButton('studenteditingother', array('studenteditingother', get_string('studenteditingother', 'dataplus'), 'dataplus'));
        
        $mform->addElement('select', 'teacherediting', get_string('teacherediting', 'dataplus'), $ynoptions);
        $mform->setHelpButton('teacherediting', array('teacherediting', get_string('teacherediting', 'dataplus'), 'dataplus'));

        $mform->addElement('select', 'teachereditingother', get_string('teachereditingother', 'dataplus'), $ynoptions);
        $mform->setHelpButton('teachereditingother', array('teachereditingother', get_string('teachereditingother', 'dataplus'), 'dataplus'));        
               
        $mform->addElement('select', 'allowcomments', get_string('allowcomments', 'dataplus'), $ynoptions);
        $mform->setHelpButton('allowcomments', array('allowcomments', get_string('allowcomments', 'dataplus'), 'dataplus')); 
        
        $mform->addElement('text', 'viewtablabel', get_string('viewtablabel', 'dataplus'), array('size'=>'20'));
        $mform->setDefault('viewtablabel',get_string('view', 'dataplus'));
        $mform->setHelpButton('viewtablabel', array('tablabel', get_string('viewtablabel', 'dataplus'), 'dataplus'));
        
        $mform->addElement('select', 'viewtabvisible', get_string('viewtabvisible', 'dataplus'), $ynoptions);
        $mform->setHelpButton('viewtabvisible', array('tabvisible', get_string('viewtabvisible', 'dataplus'), 'dataplus'));

        $mform->addElement('text', 'singlerecordtablabel', get_string('singlerecordtablabel', 'dataplus'), array('size'=>'20'));
        $mform->setDefault('singlerecordtablabel',get_string('single_record', 'dataplus'));
        $mform->setHelpButton('singlerecordtablabel', array('tablabel', get_string('singlerecordtablabel', 'dataplus'), 'dataplus'));
        
        $mform->addElement('select', 'singlerecordtabvisible', get_string('singlerecordtabvisible', 'dataplus'), $ynoptions);
        $mform->setHelpButton('singlerecordtabvisible', array('tabvisible', get_string('singlerecordtabvisible', 'dataplus'), 'dataplus'));

        $mform->addElement('text', 'searchtablabel', get_string('searchtablabel', 'dataplus'), array('size'=>'20'));
        $mform->setDefault('searchtablabel',get_string('search', 'dataplus'));
        $mform->setHelpButton('searchtablabel', array('tablabel', get_string('searchtablabel', 'dataplus'), 'dataplus'));
        
        $mform->addElement('select', 'searchtabvisible', get_string('searchtabvisible', 'dataplus'), $ynoptions);
        $mform->setHelpButton('searchtabvisible', array('tabvisible', get_string('searchtabvisible', 'dataplus'), 'dataplus'));

        $mform->addElement('text', 'addrecordtablabel', get_string('addrecordtablabel', 'dataplus'), array('size'=>'20'));
        $mform->setDefault('addrecordtablabel',get_string('addrecord', 'dataplus'));
        $mform->setHelpButton('addrecordtablabel', array('tablabel', get_string('addrecordtablabel', 'dataplus'), 'dataplus'));
        
        $mform->addElement('select', 'addrecordtabvisible', get_string('addrecordtabvisible', 'dataplus'), $ynoptions);
        $mform->setHelpButton('addrecordtabvisible', array('tabvisible', get_string('addrecordtabvisible', 'dataplus'), 'dataplus'));

        $mform->addElement('text', 'exporttablabel', get_string('exporttablabel', 'dataplus'), array('size'=>'20'));
        $mform->setDefault('exporttablabel',get_string('export', 'dataplus'));
        $mform->setHelpButton('exporttablabel', array('tablabel', get_string('exporttablabel', 'dataplus'), 'dataplus'));
        
        $mform->addElement('select', 'exporttabvisible', get_string('exporttabvisible', 'dataplus'), $ynoptions);
        $mform->setHelpButton('exporttabvisible', array('tabvisible', get_string('exporttabvisible', 'dataplus'), 'dataplus'));
        
        $mform->addElement('text', 'savebuttonlabel', get_string('savebuttonlabel', 'dataplus'), array('size'=>'20'));
		$mform->setDefault('savebuttonlabel',get_string('add', 'dataplus'));
        $mform->setHelpButton('savebuttonlabel', array('savebuttonlabel', get_string('savebuttonlabel', 'dataplus'), 'dataplus'));
	
        $limits = array();
        
        for($i=3; $i<=25; $i = $i+2){
        	$limits[$i] = $i;
        }
                                        
        $mform->addElement('select', 'navigationlimit', get_string('navigationlimit', 'dataplus'), $limits);
        $mform->setDefault('navigationlimit', 15);
        $mform->setHelpButton('navigationlimit', array('navigationlimit', get_string('navigationlimit', 'dataplus'), 'dataplus'));
                
		$mform->addElement('select', 'listperpage', get_string('listperpage', 'dataplus'), $sizes);
		$mform->setDefault('listperpage', 10);
		$mform->setHelpButton('listperpage', array('listperpage', get_string('listperpage', 'dataplus'), 'dataplus'));
	
        $this->standard_coursemodule_elements(array('groups'=>true, 'groupings'=>true, 'groupmembersonly'=>true));

//-------------------------------------------------------------------------------
        // buttons
        $this->add_action_buttons();
    }
}
?>
